package com.example.canaleschat;

import android.provider.Settings.Secure;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;
import java.net.URLEncoder;

import android.util.Log;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;

public class Chat extends Activity implements OnClickListener {
	static boolean active = false; 
	private EditText mensaje;
	private Button buttonEnviar;
	private ListView filterListView;
	private ArrayList <HashMap<String, Object>> filterListData;
	private String user="[none]";
	
	// Controla si esta o no activa la actividad del chat
	
	@Override
    public void onStart() {
       super.onStart();
       active = true;
    } 
	
    @Override
    public void onStop() {
       super.onStop();
       active = false;
     //  Log.v("Parando",""+active);
    }
	 
    // ********************************************************
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        // asignamos el user por dispositivo		
		user = Secure.getString(this.getContentResolver(), Secure.ANDROID_ID);
		setContentView(R.layout.chat);
		
		buttonEnviar = (Button) findViewById(R.id.buttonEnviar);
		mensaje = (EditText) findViewById(R.id.editTextMensaje);
		//
		buttonEnviar.setOnClickListener(this);
		filterListView = (ListView) findViewById(R.id.filtersListView);
        filterListData = new ArrayList<HashMap<String, Object>>();
        // lanzo la carga de los mensajes del chat
        GetMsgFromServerTask acceso = new GetMsgFromServerTask();
	    acceso.execute();
   }
  
	/*
	 *  Envia un nuevo mensaje
	 */
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		SetMsgChat enviar = new SetMsgChat();
		String mensajeEnviar = mensaje.getText().toString();
		// controlar el texto introducido
		mensajeEnviar = mensajeEnviar.replace(';',',').replace('#', '@');
		if(mensajeEnviar!=null && mensajeEnviar.length()>0)
		enviar.execute(mensajeEnviar);

	}
	
	/*
     *  Se encarga de cargar los mensajes en segundo plano mientras 
     *  la actividad esta en lnea
     */
	class GetMsgFromServerTask extends AsyncTask<Void, String, Void> {

	    private final ReentrantLock lock = new ReentrantLock();
	    private final Condition espera = lock.newCondition();
	  
	    @Override
	    protected Void doInBackground(Void... params) {
            try {
		
            	lock.lockInterruptibly();
		        
            	do { 
		        	
		           Vector<String> result = new Vector<String>();
			        HttpURLConnection conexion = null;
			        try { 
			        	String host = "http://www.coicoy.com/msgm/getMsgCanal.php"+ "?nombrecanal="+  URLEncoder.encode(Canal.canalSeleccionado, "UTF-8");
			        	URL url=new URL(host);
			        	// Log.v ("Host Mesajes", host);
			        	conexion = (HttpURLConnection) url .openConnection();
			            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
			                 BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
			                 String linea = "";
			                 while ((linea=reader.readLine()) !=null) {
			                     result.add(linea);
			                 }
			                 reader.close();
			                 conexion.disconnect();
			               
			            } else {
			                if(conexion!=null) conexion.disconnect();
			                
			            }
			        } catch (Exception e) {
			               if(conexion!=null) conexion.disconnect();
			        }
			     
		              publishProgress(result.toString());
		              espera.await(2,TimeUnit.SECONDS);

		        } while(active);

            	lock.unlock();
				
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			return null;
	    }

	    @Override
	    protected void onProgressUpdate(String... result) 
	    {

	    	String mensaje = result[0];
	    //	Log.v("mensaje", mensaje);
	    			
	    	if(mensaje!= null && !mensaje.equals("[]")){
	    		
				HashMap<String, Object> fillMap = null;
				filterListData = new ArrayList <HashMap<String, Object>>();
				mensaje = mensaje.substring(1,mensaje.length()-1);
                StringTokenizer registros = new StringTokenizer(mensaje, "#");
                //    
                while(registros.hasMoreTokens()) {
                	String r = registros.nextToken();
                	StringTokenizer campos = new StringTokenizer(r, ";");
                	String user_ =  campos.nextToken();
                	String fechaCreacion =  campos.nextToken();
                	String mensajes =  campos.nextToken();
                	fillMap = new HashMap<String, Object>();
                	if(user_.equals(user)) mensajes = "yo: "+ mensajes;
                	fillMap.put("fechaCreaccion", fechaCreacion);
                    fillMap.put("mensaje", mensajes);
        		    filterListData.add(fillMap);
                }
                SimpleAdapter filtersListAdapter = new SimpleAdapter(
				           Chat.this.getBaseContext(),
					       filterListData, 
					       R.layout.filters_list_msg_row,
					       new String[] { "fechaCreaccion","mensaje" },
					       new int[] { R.id.filterFechaCreaccion, R.id.filterMensaje }
		         );

                filterListView.setAdapter(filtersListAdapter);
			}
				    
				   
        	}
	    
	    public void terminateTask() {
	        active = false;
	        lock.unlock();
	    }

	    @Override
	    protected void onCancelled() {
	        terminateTask();
	    }
		
	}
			
	/*
	 *  Envia un mensaje
	 */
	
	 /*
     *  Se encarga de cargar los mensajes en segundo plano mientras 
     *  la actividad esta en lnea
     */

	public class SetMsgChat extends AsyncTask<String, Void, String> {
		@Override
		protected String doInBackground(String... msg) {
	
			Vector<String> result = new Vector<String>();
	        HttpURLConnection conexion = null;
	        try { 
	        	String host = "http://www.coicoy.com/msgm/setMsgCanal.php"+ "?nombrecanal="+  URLEncoder.encode(Canal.canalSeleccionado, "UTF-8")
	        			+ "&user=" + URLEncoder.encode(user, "UTF-8") + "&mensaje=" +URLEncoder.encode( msg[0], "UTF-8");
	        	URL url = new URL(host);
	        //	Log.v ("Host Envio", host);
	        	conexion = (HttpURLConnection) url .openConnection();
	            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
	                 BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
	                 String linea = "";
	                 while ((linea=reader.readLine()) !=null) {
	                     result.add(linea);
	                 }
	                 reader.close();
	                 conexion.disconnect();
	                 return result.toString();
	            } else {
	                if(conexion!=null) conexion.disconnect();
	                return result.toString();
	            }
	        } catch (Exception e) {
	               if(conexion!=null) conexion.disconnect();
	               return result.toString();
	        }

		}
		/*  Realiza la carga en las lista de mensajes
		 *  formato mensaje, ";" separacion entre campos "#" entre registros
		 */
		protected void onPostExecute(String _mensaje) {
			if(_mensaje== null || _mensaje.equals("[]") || !_mensaje.equals("[OK]") ){
				// Error mandando el mensaje
				Toast.makeText(Chat.this, "Error al enviar\n",Toast.LENGTH_SHORT).show();
			}else{
				mensaje.setText("");
			}
		}
		
	}
	//
	
	
	
	
}
